﻿Imports System.IO
Imports System.Net
Imports System.Text
Imports Newtonsoft.Json

Module Module1
    '商户号'
    Private Const merchantno As String = "xxxxxxxxxxxxxxxxxxxxx"
    '终端号'
    Private Const terminal As String = "xxxxxxxxx"
    '秘钥'
    Private Const token As String = "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx"
    '支付地址'
    Private url As String = "http://test.lcsw.cn:8045/lcsw"


    Sub Main()
        barcodepay("xxxxxxxxxxxxxxxxxx")
        '扫码支付'
        prepay()
        '公众号预支付（统一下单）'
        jspay()
        '小程序支付'
        minipay()
        '查询'
        query("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx")
        query("xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx", "xxxxxxxxxxxxxxxxxxxx")
        '退款'
        refund("1", "xxxxxxxxxxxxxxxxxxxxxxxx")
        '聚合码
        qrpay()
    End Sub

    '付款码支付'
    Sub barcodepay(ByVal auth_no As String)
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "000")
        dic.Add("service_id", "010")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("auth_no", auth_no)
        dic.Add("total_fee", "1") '金额 单位分'
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/barcodepay", dic)
    End Sub


    '扫码支付'
    Sub prepay()
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "010")
        dic.Add("service_id", "011")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("total_fee", "1") '金额 单位分'
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/prepay", dic)
    End Sub



    '公众号预支付'
    Sub jspay()
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "010")
        dic.Add("service_id", "012")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("total_fee", "1") '金额 单位分'
        dic.Add("open_id","xxxxxxxxxxxxxxxxxxxxx")
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/jspay", dic)
    End Sub


    '小程序 通过我们接口的返参调用微信官方的支付，我们接口如下，微信官方请查看微信官方文档'
    Sub minipay()
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "010")
        dic.Add("service_id", "015")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("total_fee", "1") '金额 单位分'
        dic.Add("open_id","xxxxxxxxxxxxxxxxxxxxxx")
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/minipay", dic)
    End Sub

    '聚合码支付'
    Sub qrpay()
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "000")
        dic.Add("service_id", "016")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("total_fee", "1") '金额 单位分'
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/qrpay", dic)
    End Sub

    '订单号查询'
    Sub query(ByVal out_trade_no As String)
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "000")
        dic.Add("service_id", "020")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("pay_trace", "") 
        dic.Add("pay_time","")
        dic.Add("out_trade_no",out_trade_no)
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/query", dic)
    End Sub

    '流水+时间查询'
    Sub query(pay_trace As String,pay_time As String)
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "000")
        dic.Add("service_id", "020")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("pay_trace", pay_trace) 
        dic.Add("pay_time",pay_time)
        dic.Add("out_trade_no","")
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/query", dic)
    End Sub

    Sub refund(fee As String,out_trade_no As String)
        Dim dic = New Dictionary(Of String, String)
        dic.Add("pay_ver", "110")
        dic.Add("pay_type", "000")
        dic.Add("service_id", "030")
        dic.Add("merchant_no", merchantno)
        dic.Add("terminal_id", terminal)
        dic.Add("terminal_trace", Guid.NewGuid().ToString("N"))
        dic.Add("terminal_time", DateTime.Now.ToString("yyyyMMddHHmmss"))
        dic.Add("refund_fee",fee)
        dic.Add("out_trade_no",out_trade_no)
        dic.Add("key_sign", Md5Encryption(dic))
        Dim result = HttpPost(url + "/pay/110/refund", dic)
    End Sub

    '计算签名'
    Private Function Md5Encryption(ByRef dic As Dictionary(Of String, String)) As String
        Dim sb = New StringBuilder()
        '按字典序排序后的集合'
        Dim sortdic = dic.OrderBy(Function(f) f.Key).ToList()
        For j = 0 To sortdic.Count - 1
            If Not IsDBNull(sortdic(j).Value) Then
                sb.Append(sortdic(j).Key + "=" + sortdic(j).Value + "&")
            End If
        Next
        sb.Append("access_token=" + token)
        Dim md5 = System.Security.Cryptography.MD5.Create()
        Dim bs = md5.ComputeHash(Encoding.UTF8.GetBytes(sb.ToString()))
        Dim str = New StringBuilder()
        For x = 0 To bs.Count - 1
            str.Append(bs(x).ToString("x2"))
        Next
        Return str.ToString().ToUpper()
    End Function

    'http request'
    Private Function HttpPost(ByVal postUrl As String, ByRef dictionary As Dictionary(Of String, String)) As String
        Try
            Dim result As String = String.Empty
            Dim req As HttpWebRequest
            req = CType(WebRequest.Create(postUrl), HttpWebRequest)
            req.Method = "POST"
            req.Timeout = 8000
            req.ContentType = "application/json"
            Dim bytesData() As Byte = Encoding.UTF8.GetBytes(JsonConvert.SerializeObject(dictionary))
            req.ContentLength = bytesData.Length
            Dim postStream As Stream = req.GetRequestStream()
            postStream.Write(bytesData, 0, bytesData.Length)
            postStream.Close()
            Dim res = CType(req.GetResponse(), HttpWebResponse)
            Dim Stream As Stream = res.GetResponseStream()
            Dim reader = New StreamReader(Stream, Encoding.UTF8)
            result = reader.ReadToEnd()
            res.Close()
            reader.Close()
            Stream.Close()
            Return result
        Catch ex As Exception
            Return ""
        End Try

    End Function
End Module


